## org.biojava.bio.dp
Class AbstractTrainer

    java.lang.Object
      |
      +--org.biojava.bio.dp.AbstractTrainer

Direct Known Subclasses:
  BaumWelchSampler, BaumWelchTrainer

public abstract class AbstractTrainer
extends java.lang.Object
implements TrainingAlgorithm

Constructor Summary
`protected` `AbstractTrainer()`
`` `AbstractTrainer(DP dp)`

Method Summary
`double` `getCurrentScore()`
`int` `getCycle()`
`DP` `getDP()`
`double` `getLastScore()`
`protected abstract double` `singleSequenceIteration(ModelTrainer trainer, SymbolList resList)`
`void` `train(SequenceDB db, Distribution nullModel, double nullWeight, StoppingCriteria stopper)` Trains the sequences in db until stopper says to finnish.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AbstractTrainer

    public AbstractTrainer(DP dp)

### AbstractTrainer

    protected AbstractTrainer()

Method Detail

### getLastScore

    public double getLastScore()

  Specified by:
    getLastScore in interface TrainingAlgorithm

### getCurrentScore

    public double getCurrentScore()

  Specified by:
    getCurrentScore in interface TrainingAlgorithm

### getCycle

    public int getCycle()

  Specified by:
    getCycle in interface TrainingAlgorithm

### getDP

    public DP getDP()

  Specified by:
    getDP in interface TrainingAlgorithm

### singleSequenceIteration

    protected abstract double singleSequenceIteration(ModelTrainer trainer,
                                                      SymbolList resList)
                                               throws IllegalSymbolException,
                                                      IllegalTransitionException,
                                                      IllegalAlphabetException

### train

    public void train(SequenceDB db,
                      Distribution nullModel,
                      double nullWeight,
                      StoppingCriteria stopper)
               throws IllegalSymbolException,
                      BioException

  Trains the sequences in db until stopper says to finnish.
  Specified by:
    train in interface TrainingAlgorithm